//
//  _ΉtvO
//
#include <stdio.h>
#include <cv.h>
#include <highgui.h>
#include <nonfree/nonfree.hpp>	// ver.2.4Kv
#include <vector>
using namespace std;


// \p摜̍쐬
IplImage* stack_imgs( IplImage* img1, IplImage* img2 )
{
	IplImage* stacked = cvCreateImage( cvSize( MAX(img1->width, img2->width),
		img1->height + img2->height ),
		IPL_DEPTH_8U, 3 );

	cvZero( stacked );
	cvSetImageROI( stacked, cvRect( 0, 0, img1->width, img1->height ) );
	cvAdd( img1, stacked, stacked, NULL );
	cvSetImageROI( stacked, cvRect(0, img1->height, img2->width, img2->height) );
	cvAdd( img2, stacked, stacked, NULL );
	cvResetImageROI( stacked );

	return stacked;
}

// zOtBHgĎΉeϊs[`
CvPoint persp_xform_pt( CvPoint & pt, cv::Mat & H )
{
	CvPoint ret;

	CvMat XY, UV;
	double xy[3] = { pt.x, pt.y, 1.0 }, uv[3] = { 0 };
	CvPoint2D64f rslt;

	cvInitMatHeader( &XY, 3, 1, CV_64FC1, xy, CV_AUTOSTEP );
	cvInitMatHeader( &UV, 3, 1, CV_64FC1, uv, CV_AUTOSTEP );
	CvMat T = H;
	cvMatMul( &T, &XY, &UV );
	rslt = cvPoint2D64f( uv[0] / uv[2], uv[1] / uv[2] );

	ret.x = rslt.x;
	ret.y = rslt.y;
	return ret;
}


int main (int argc, char **argv)
{

	CvMemStorage *storage = cvCreateMemStorage (0);

	if (argc == 1) {
		fprintf (stderr, "usage: %s input_imagefile\n", argv[0]);
		exit (0);
	}

	// EChE̐ݒ
	cvNamedWindow ("srcimage", CV_WINDOW_AUTOSIZE);    //͉摜\p
	cvNamedWindow ("livecapture", CV_WINDOW_AUTOSIZE); //Lv`摜\p

	// Lv`foCX̐ݒ
	CvCapture *cap;
	IplImage  *cap_img_rgb = 0;
	IplImage  *cap_img_gray = 0;

	cap = cvCreateCameraCapture(CV_CAP_ANY);

	if (cap == NULL) {
		fprintf (stderr, "cvCreateCameraCapture() failed...\n");
		exit (0);
	}
	cvSetCaptureProperty (cap, CV_CAP_PROP_FRAME_WIDTH,  320);
	cvSetCaptureProperty (cap, CV_CAP_PROP_FRAME_HEIGHT, 240);

	// ͉摜_𒊏o
	IplImage* src_img_rgb = cvLoadImage (argv[1]);


	// ͉摜̓_\
	IplImage* src_img_gray = 0;
	if (src_img_gray == 0) {
		src_img_gray = cvCreateImage (cvGetSize(src_img_rgb), 8, 1);
	}
	cvCvtColor (src_img_rgb, src_img_gray, CV_RGB2GRAY);

	// JLv`摜郋[v

	double threshold      = 1.0;
	double edge_threshold = 8.0;
	double magnification  = 3.0;

	// SIFT̓_oEʒop
	cv::SiftFeatureDetector detector(threshold, edge_threshold );
	cv::SiftDescriptorExtractor extractor( magnification );

	// SURF̏ꍇ
	//cv::SurfFeatureDetector detector;
	//cv::SurfDescriptorExtractor extractor;

	// 摜1_o
	std::vector<cv::KeyPoint> keypoints1;
	cv::Mat mat1(src_img_gray);
	detector.detect( mat1, keypoints1 );
	// 摜1̓_ɂʂ𒊏o
	cv::Mat descriptor1;
	extractor.compute( mat1, keypoints1, descriptor1 );

	//\po͉摜
	IplImage * stacked;


	while (true) {
		double st = (double)cvGetTickCount();
		// Lv`foCX摜擾
		cap_img_rgb = cvQueryFrame (cap);

		if (cap_img_gray == 0) {
			cap_img_gray = cvCreateImage (cvGetSize(cap_img_rgb), 8, 1);
		}
		cvCvtColor (cap_img_rgb, cap_img_gray, CV_RGB2GRAY);

		// 摜2_o
		cv::Mat mat(cap_img_gray);

		std::vector<cv::KeyPoint> keypoints2;
		detector.detect( mat, keypoints2 );


		// 摜2̓_ɂʂ𒊏o
		cv::Mat descriptor2;
		extractor.compute( mat, keypoints2, descriptor2 );

		// Ή_߂
		vector< cv::DMatch > matches_o;
		vector< cv::DMatch > matches;

		// ʔrɂ_̑Ήt
		cv::FlannBasedMatcher matcher;
		matcher.match(descriptor2, descriptor1, matches_o );
		// ގxΉt݂̂𒊏o
		for(int i = 0;i < matches_o.size();i++)
		{
			if(sqrt(matches_o[i].distance/128.0) < 1.5)
			{
				matches.push_back(matches_o[i]);
			}
		}


		// `p摜̍쐬
		stacked = stack_imgs( src_img_rgb, cap_img_rgb);

		// _`
		for(int i = 0;i < keypoints1.size();i++)
		{
			CvPoint center;
			center.x = keypoints1[i].pt.x;
			center.y = keypoints1[i].pt.y;
			cvCircle(stacked, center, 2, CV_RGB(160,0,0)); 
		};
		for(int i = 0;i < keypoints2.size();i++)
		{
			CvPoint center;
			center.x = keypoints2[i].pt.x;
			center.y = keypoints2[i].pt.y + src_img_rgb->height;
			cvCircle(stacked, center, 2, CV_RGB(160,0,0)); 
		};

		if(matches.size() > 4)
		{
			std::vector< cv::Vec2f > points1( matches.size());
			std::vector< cv::Vec2f > points2( matches.size());
			for(int i = 0;i < matches.size();i++)
			{
				CvPoint pt1, pt2;
				pt1.x = keypoints1[matches[i].trainIdx].pt.x;
				pt1.y = keypoints1[matches[i].trainIdx].pt.y;
				pt2.x = keypoints2[matches[i].queryIdx].pt.x;
				pt2.y = keypoints2[matches[i].queryIdx].pt.y + src_img_rgb->height;
				cvLine(stacked, pt1,pt2, CV_RGB(255,0,0));

				// Ή_yA̍쐬
				pt1.x = keypoints1[matches[i].trainIdx].pt.x;
				pt1.y = keypoints1[matches[i].trainIdx].pt.y;
				pt2.x = keypoints2[matches[i].queryIdx].pt.x;
				pt2.y = keypoints2[matches[i].queryIdx].pt.y;
				points1[i][0] = pt1.x;
				points1[i][1] = pt1.y;
				points2[i][0] = pt2.x;
				points2[i][1] = pt2.y;
			};
			// RANSACɂzOtBvZ
			cv::Mat H;		
			H = cv::findHomography( points1, points2,  CV_RANSAC, 5.0);	

			// ʂ`
			{
				CvPoint pt1, pt2;
				int B = 40;
				CvPoint xpt1, xpt2, xpt3, xpt4, pt;
				pt.x = 128-B;pt.y = 128 - B;
				xpt1 = persp_xform_pt( pt, H );
				pt.x = 128+B;pt.y = 128 - B;
				xpt2 = persp_xform_pt( pt, H );
				pt.x = 128+B;pt.y = 128 + B;
				xpt3 = persp_xform_pt( pt, H );
				pt.x = 128-B;pt.y = 128 + B;
				xpt4 = persp_xform_pt( pt, H );
				pt1.x = xpt1.x;pt1.y = xpt1.y + src_img_rgb->height;
				pt2.x = xpt2.x;pt2.y = xpt2.y + src_img_rgb->height;
				cvLine( stacked, pt1, pt2, CV_RGB(0, 255, 0), 2, 8, 0 );
				pt1.x = xpt2.x;pt1.y = xpt2.y + src_img_rgb->height;
				pt2.x = xpt3.x;pt2.y = xpt3.y + src_img_rgb->height;
				cvLine( stacked, pt1, pt2, CV_RGB(0, 255, 0), 2, 8, 0 );
				pt1.x = xpt3.x;pt1.y = xpt3.y + src_img_rgb->height;
				pt2.x = xpt4.x;pt2.y = xpt4.y + src_img_rgb->height;
				cvLine( stacked, pt1, pt2, CV_RGB(0, 255, 0), 2, 8, 0 );
				pt1.x = xpt4.x;pt1.y = xpt4.y + src_img_rgb->height;
				pt2.x = xpt1.x;pt2.y = xpt1.y + src_img_rgb->height;
				cvLine( stacked, pt1, pt2, CV_RGB(0, 255, 0), 2, 8, 0 );
			}
		};
		// ʂ\
		cvShowImage("livecapture", stacked);

		// ESCL[I
		int c = cvWaitKey(10);
		if (c == 27) break;
	}

	// I
	cvDestroyAllWindows ();
	cvReleaseImage (&src_img_gray);
	cvReleaseImage (&src_img_rgb);
	cvReleaseImage (&cap_img_gray);
	cvReleaseCapture (&cap);
	cvReleaseMemStorage (&storage);

	return (0);
}
